
set echo on
set serveroutput on format wrapped

TRUNCATE TABLE errors;

DECLARE

   v_package       errors.package_name%TYPE   := 'ANON. BLOCK';
   v_procedure     errors.procedure_name%TYPE := 'ANON. BLOCK';
   v_action        errors.action%TYPE;
   v_business_date errors.business_date%TYPE := TRUNC(SYSDATE)-1;
   v_business_key  errors.business_key%TYPE;

BEGIN

   v_action := 'Process source data';
   FOR r IN ( SELECT object_id   AS key_attr1
              ,      object_name AS key_attr2
              ,      object_type AS data_attr1
              FROM   user_objects )
   LOOP

      v_action := 'Assign business key';
      v_business_key := r.key_attr1 || ',' || r.key_attr2;

      v_action := 'Transformation and business rules';
      r.data_attr1 := RPAD('Oops',4000);  --<-- oh dear

   END LOOP;

EXCEPTION
   WHEN OTHERS THEN
      error.log( p_owner         => USER,
                 p_package       => v_package,
                 p_procedure     => v_procedure,
                 p_action        => v_action,
                 p_business_date => v_business_date,
                 p_business_key  => v_business_key );

      ROLLBACK; --<-- error package should encapsulate this...
      RAISE;    --<-- error package should also encapsulate this...
END;
/

exec print_table('SELECT * FROM errors');

